## org.biojava.bio.dp
Class BaumWelchSampler

    java.lang.Object
      org.biojava.bio.dp.AbstractTrainer
          org.biojava.bio.dp.BaumWelchSampler

All Implemented Interfaces:
  Serializable, TrainingAlgorithm

    public class BaumWelchSampler

extends AbstractTrainer
implements Serializable

Train a hidden markov model using a sampling algorithm.

Note: this class currently only works for one-head models.

Since:
  1.0
Author:
  Matthew Pocock, Richard Holland
See Also:
  Serialized Form

Constructor Summary
`BaumWelchSampler(DP dp)`

Method Summary
`protected double` `singleSequenceIteration(ModelTrainer trainer, SymbolList symList)`
`protected double` `singleSequenceIteration(ModelTrainer trainer, SymbolList symList, ScoreType scoreType)`

Methods inherited from class org.biojava.bio.dp.AbstractTrainer
`getCurrentScore, getCycle, getDP, getLastScore, train`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BaumWelchSampler

    public BaumWelchSampler(DP dp)

Method Detail

### singleSequenceIteration

    protected double singleSequenceIteration(ModelTrainer trainer,
                                             SymbolList symList)
                                      throws IllegalSymbolException,
                                             IllegalTransitionException,
                                             IllegalAlphabetException

  Specified by:
    `singleSequenceIteration` in class `AbstractTrainer`
  Throws:
    `IllegalSymbolException`
    `IllegalTransitionException`
    `IllegalAlphabetException`

### singleSequenceIteration

    protected double singleSequenceIteration(ModelTrainer trainer,
                                             SymbolList symList,
                                             ScoreType scoreType)
                                      throws IllegalSymbolException,
                                             IllegalTransitionException,
                                             IllegalAlphabetException

  Throws:
    `IllegalSymbolException`
    `IllegalTransitionException`
    `IllegalAlphabetException`